# Rust编程指南

[Rust编程指南](about.md)
[进入Rust语言世界](into-rust.md)

## Getting started

- [牛刀小试](first-try/intro.md)
    - [安装Rust环境(todo)](first-try/installation.md)
    - [墙推VSCode!(todo)](first-try/editor.md)
    - [认识Cargo(todo)](first-try/cargo.md)
    - [你好，世界!(todo)](first-try/hello-world.md)

## Rust学习三部曲

- [基本概念](basic/intro.md)
    - [变量与绑定](basic/variable.md)
    - [基本类型(todo)](basic/type.md)
    - [复合类型(todo)](basic/compound-type.md)
    - [函数与方法(todo)](basic/function-method.md)
    - [格式化输出(todo)](basic/formatted-output.md)
    - [字符串、数组与切片(todo)](basic/string-array-slice.md)
    - [流程控制(todo)](basic/flow-control.md)
    - [返回、异常和错误(todo)](basic/exception-error.md)
    - [模式匹配(todo)](basic/match-pattern.md)
    - [文档注释(todo)](basic/comment.md)
    - [包和模块(todo)](basic/crate-module.md)
    - [语句与表达式(todo)](basic/statement-expression.md)

- [核心概念](core/intro.md)
    - [所有权(todo)](core/ownership.md)
    - [借用(todo)](core/borrowing.md)
    - [生命周期(todo)](core/lifetime.md)
    
- [进阶编程](advance/intro.md)
    - [泛型(todo)](advance/generitic.md)
    - [特征(todo)](advance/trait.md)
    - [迭代器(todo)](advance/interator.md)
    - [集合类型(todo)](advance/collection.md)
    - [函数式编程(todo)](advance/functional-programing.md)
    - [智能指针(todo)](advance/smart-pointer.md)
    - [多线程(todo)](advance/threads.md)
    - [测试(todo)](advance/tests.md)
    - [错误处理(todo)](advance/errors.md)
    - [宏(todo)](advance/macro.md)
    - [Bypass Borrow Checker(todo)](advance/bypass-borrow.md)
    - [常用三方库列表(todo)](advance/utils.md)

## 专题内容

- [代码风格](style-guide/intro.md)
    - [命名规范](style-guide/naming.md)
- [面向对象](object-oriented/intro.md)
    - [OO所需的特性(todo)](object-oriented/characteristics.md)
- [异步编程](async/intro.md)
    - [并发与并行(todo)](async/concurrency-parallelism.md)
- [Cargo详解](cargo/intro.md)
    - [配置参数(todo)](cargo/manifest.md)
- [性能调优](performance/intro.md)
    - [Benchmark性能测试(todo)](performance/benchmark.md)
    - [减少Runtime check(todo)](performance/runtime-check.md)
- [Unsafe](unsafe/intro.md)
    - [原始指针(todo)](unsafe/raw-pointer.md)
- [宏编程](macro/intro.md)
    - [过程宏(todo)](macro/procedure-macro.md)
- [常用三方库](third-party/intro.md)
    - [serde(todo)](third-party/serde.md)

## 场景模版

- [场景示例(todo)](use-case/intro.md)


## 附录
- [附录](appendix/intro.md)
    - [A-关键字](appendix/a-keywords.md)